import { renderless, api } from '@opentinyvue/vue-renderless/autocomplete/vue';
import { defineComponent, directive, props, setup } from '@opentinyvue/vue-common';
import Scrollbar from '@opentinyvue/vue-scrollbar';
import Input from '@opentinyvue/vue-input';
import { Clickoutside } from '@opentinyvue/vue-directive';
import { IconLoadingShadow } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  components: {
    TinyInput: Input,
    TinyScrollbar: Scrollbar,
    IconLoadingShadow: IconLoadingShadow()
  },
  directives: directive({
    Clickoutside
  }),
  props: [].concat(props, ["valueKey", "popperClass", "tabindex", "popperOptions", "placeholder", "clearable", "disabled", "name", "size", "modelValue", "maxlength", "minlength", "autofocus", "fetchSuggestions", "triggerOnFocus", "customItem", "selectWhenUnmatched", "prefixIcon", "suffixIcon", "label", "debounce", "placement", "hideLoading", "popperAppendToBody", "highlightFirstItem", "displayOnly", "validateEvent"]),
  emits: ["update:modelValue", "focus", "blur", "clear", "select", "created"],
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.close,
      expression: "close"
    }],
    class: ["tiny-autocomplete", {
      "show-auto-width": _vm.state.showAutoWidth
    }],
    attrs: {
      "aria-haspopup": "listbox",
      "role": "combobox",
      "aria-expanded": _vm.state.suggestionVisible,
      "aria-owns": _vm.state.id
    }
  }, [_c("tiny-input", _vm._b({
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.handleBlur,
      expression: "handleBlur"
    }],
    ref: "input",
    attrs: {
      "tabindex": _vm.tabindex,
      "display-only": _vm.displayOnly,
      "front-clear-icon": "",
      "validate-event": false
    },
    on: {
      "update:modelValue": _vm.handleChange,
      "focus": _vm.handleFocus,
      "clear": _vm.handleClear,
      "keydown": [function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) return null;
        $event.preventDefault();
        return _vm.highlight(_vm.state.highlightedIndex - 1);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) return null;
        $event.preventDefault();
        return _vm.highlight(_vm.state.highlightedIndex + 1);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
        return _vm.handleKeyEnter.apply(null, arguments);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) return null;
        return _vm.close.apply(null, arguments);
      }]
    },
    scopedSlots: _vm._u([_vm.slots.prepend ? {
      key: "prepend",
      fn: function fn() {
        return [_vm._t("prepend")];
      },
      proxy: true
    } : null, _vm.slots.append ? {
      key: "append",
      fn: function fn() {
        return [_vm._t("append")];
      },
      proxy: true
    } : null, _vm.slots.prefix ? {
      key: "prefix",
      fn: function fn() {
        return [_vm._t("prefix")];
      },
      proxy: true
    } : null, _vm.slots.suffix ? {
      key: "suffix",
      fn: function fn() {
        return [_vm._t("suffix")];
      },
      proxy: true
    } : null], null, true)
  }, "tiny-input", _vm.f(_vm.$props, _vm.$attrs), false)), _c("transition", {
    attrs: {
      "name": "tiny-zoom-in-top"
    },
    on: {
      "after-leave": _vm.doDestroy
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.hideLoading ? _vm.suggestionState.showPopper && !_vm.state.loading : _vm.suggestionState.showPopper,
      expression: "hideLoading ? suggestionState.showPopper && !state.loading : suggestionState.showPopper"
    }],
    ref: "popper",
    staticClass: "tiny-autocomplete-suggestion tiny-popper",
    class: [_vm.popperClass ? _vm.popperClass : "", {
      "is-loading": !_vm.hideLoading && _vm.state.loading
    }],
    style: {
      width: _vm.suggestionState.dropdownWidth
    },
    attrs: {
      "role": "region"
    }
  }, [_c("tiny-scrollbar", {
    attrs: {
      "tag": "ul",
      "wrap-class": "tiny-autocomplete-suggestion__wrap",
      "view-class": "tiny-autocomplete-suggestion__list"
    }
  }, [_vm._t("panel", function() {
    return [!_vm.hideLoading && _vm.state.loading ? _c("li", {
      staticClass: "tiny-autocomplete-suggestion__list-item tiny-autocomplete-suggestion__list-loading",
      attrs: {
        "role": "loading"
      }
    }, [_c("icon-loading-shadow")], 1) : _vm._l(_vm.state.suggestions, function(item, index) {
      return _c("li", {
        key: index,
        staticClass: "tiny-autocomplete-suggestion__list-item",
        class: {
          highlighted: _vm.state.highlightedIndex === index,
          selected: _vm.modelValue === item[_vm.valueKey]
        },
        attrs: {
          "id": _vm.state.id + "-item-" + index,
          "role": "option",
          "aria-selected": _vm.state.highlightedIndex === index
        },
        on: {
          "click": function click($event) {
            return _vm.select(item);
          }
        }
      }, [_vm._t("default", function() {
        return [_vm._v(" " + _vm._s(item[_vm.valueKey]) + " ")];
      }, {
        "slotScope": item
      })], 2);
    })];
  }, {
    "loading": !_vm.hideLoading && _vm.state.loading,
    "list": _vm.state.suggestions,
    "highlighted": _vm.state.highlightedIndex,
    "id": _vm.state.id,
    "select": _vm.select
  })], 2)], 1)])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
